###################
#section 3.4 (Extensive study)
###################
rm(list=ls())
library(missForest)
library(mvtnorm)
library(missMDA)
#library(AER)
#library(ipred)
setwd("D:/Documents and Settings/PRI.MATH0957/Bureau/Audigier_Donnees_Manquantes/Dropbox/Vincent_NA/imputation_FAMD/")
source("MonmissForest.r")
source("AFDM_RF.r")

Sim<-200

###################
#parameter definition for each configuration
###################
Parameters<-matrix(NA,32,5)
colnames(Parameters)<-c("n","p","K1/K","q","SNR")
Parameters[1:(2^4),1]<-50;Parameters[(2^4+1):(2^5),1]<-200
Parameters[,2]<-24
Parameters[rep(c(rep(TRUE,8),rep(FALSE,8)),2),2]<-12
Parameters[,3]<-1/3
Parameters[rep(c(rep(TRUE,4),rep(FALSE,4)),4),3]<-2/3
Parameters[,4]<-6
Parameters[rep(c(rep(TRUE,2),rep(FALSE,2)),8),4]<-3
Parameters[,5]<-rep(c(2,4),16)
Parameters.list<-list()
for (i in 1:32){
  set.seed(0)
  taille<-Parameters[i,"n"]
  V<-matrix(0,Parameters[i,"p"],Parameters[i,"p"])
  V[1:(Parameters[i,"p"]/2),1:(Parameters[i,"p"]/2)]<-1
  V[(Parameters[i,"p"]/2+1):Parameters[i,"p"],(Parameters[i,"p"]/2+1):Parameters[i,"p"]]<-1
  nb.quanti<-(Parameters[i,"p"]*Parameters[i,"K1/K"])
  quanti<-c(1:(nb.quanti/2),(Parameters[i,"p"]/2+1):((Parameters[i,"p"]/2+1)+nb.quanti/2-1))
  mod<-rep(Parameters[i,"q"],Parameters[i,"p"]-nb.quanti)
  sigma.quanti<-1/Parameters[i,"SNR"]^2
  if(i<17){sigma.quali<-Simulation.snr(V=V[-quanti,-quanti],quanti=NULL,mod,taille=200,snr.quali=Parameters[i,"SNR"])$sigma[[2]]
  }else{sigma.quali<-Parameters.list[[i-16]]$sigma.quali}
  Parameters.list[[i]]<-list(V=V,taille=taille,mod=mod,quanti=quanti,sigma.quanti=sigma.quanti,sigma.quali=sigma.quali)
}
names(Parameters.list)<-paste("config",1:length(Parameters.list))
#save(Parameters.list,file="Parameters.list.Rdata")
#load("Parameters.list.Rdata")

###################
#performing simulations
###################
simu.comp<-array(NA,dim=c(32,Sim,4),dimnames=list(paste("config",1:32),paste("Sim",1:Sim),c("FAMD PFC","FAMD NRSME","RF PFC","RF NRMSE")))
for (config in 1:32){
  print(config)
  set.seed(0)
  Jeu<-Simulation(V=Parameters.list[[config]]$V,
                  quanti=Parameters.list[[config]]$quanti,
                  mod=Parameters.list[[config]]$mod,
                  taille=Parameters.list[[config]]$taille,
                  sigma.quanti=Parameters.list[[config]]$sigma.quanti,
                  sigma.quali=Parameters.list[[config]]$sigma.quali)
  for (sim in 1:Sim){
  Comp<-AFDM.RF(Jeu,don.na=Mcar(Jeu$Jeu_bruite,p=0.1),ncp=2*(Parameters.list[[config]]$mod[[1]]-1))
  simu.comp[config,sim,]<-c(Comp$ErrAFDM[,1],Comp$ErrRF[,1])
  }
  #save(simu.comp,file=paste("simu.comp.Rdata",sep="")) 
}
#load("simu.comp.Rdata")

###################
#printing results
###################
Err<-round(cbind(Parameters,apply(simu.comp,MARGIN=c(1,3),mean)[,c(1,3,2,4)]),3)
Err
#write.table(Err,file="simu.comp.txt",sep="&",row.names=F)

#snr
(Err[seq(1,32,2),6:9]-Err[-seq(1,32,2),6:9])
#nb ind
(Err[seq(1,16,1),6:9]-Err[-seq(1,16,1),6:9])
#nb var
Err[which(Err[,"p"]==12),6:9]-Err[-which(Err[,"p"]==12),6:9]
#nb mod
Err[which(Err[,"q"]==3),6:9]-Err[-which(Err[,"q"]==3),6:9]
#K1/K
Err[which(Err[,"K1/K"]==0.667),6:9]-Err[-which(Err[,"K1/K"]==0.667),6:9]
#FAMD>RF
colSums(Err[,c(6,8)]<Err[,c(7,9)])

